;******************************************************************************
;* ASM STUFF                                                                  *
;******************************************************************************
.586p
.mmx		
.model flat, stdcall
option casemap :none

;******************************************************************************
;* INCLUDES (better too much...)                                              *
;******************************************************************************
include 		\masm32\include\windows.inc
include 		\masm32\include\user32.inc
include 		\masm32\include\kernel32.inc
include 		\masm32\include\shell32.inc
include 		\masm32\include\advapi32.inc
include 		\masm32\include\gdi32.inc
include 		\masm32\include\comctl32.inc
include 		\masm32\include\comdlg32.inc
include 		\masm32\include\ole32.inc
include 		\masm32\include\oleaut32.inc
include 		\masm32\include\masm32.inc
include 		\masm32\macros\macros.asm

includelib 		\masm32\lib\user32.lib
includelib 		\masm32\lib\kernel32.lib
includelib 		\masm32\lib\shell32.lib
includelib 		\masm32\lib\advapi32.lib
includelib 		\masm32\lib\gdi32.lib
includelib 		\masm32\lib\comctl32.lib
includelib		\masm32\lib\comdlg32.lib
includelib 		\masm32\lib\ole32.lib 
includelib 		\masm32\lib\oleaut32.lib 
includelib 		\masm32\lib\masm32.lib

include    		\masm32\include\wsock32.inc
includelib 		\masm32\lib\wsock32.lib
includelib		\masm32\lib\wininet.lib
include    		\masm32\include\wininet.inc

;include	   	\masm32\include\diablo2oo2.inc
;includelib 		\masm32\lib\diablo2oo2.lib

;******************************************************************************
;* PROTOTYPES                                                                 *
;******************************************************************************
DialogProc 		PROTO :DWORD,:DWORD,:DWORD,:DWORD

;******************************************************************************
;* DATA                                                                       *
;******************************************************************************
.data?
splashscreen_hBmp	dd ?

;******************************************************************************
;* CODE                                                                       *
;******************************************************************************
.code
main:
	invoke GetModuleHandle,0
        invoke DialogBoxParam,eax,1,0,addr DialogProc,0
        invoke ExitProcess,0
        
DialogProc Proc uses ebx esi edi  hwnd:dword,message:dword,wParam:dword,lParam:dword
	LOCAL ps:PAINTSTRUCT
        LOCAL hdc:HDC
        LOCAL hMemoryDC:HDC
        LOCAL bitmap:BITMAP
	LOCAL DesktopRect:RECT
	
	mov eax,message
	.if eax==WM_INITDIALOG		
		;---load bitmap (jpg) from resource---
        	invoke FindResource,0,chr$("SPLASH"),RT_RCDATA
		mov edi,eax
		invoke SizeofResource,0,eax
		mov esi,eax
		invoke LoadResource,0,edi
		invoke BitmapFromMemory,eax,esi	;read jpg
		mov splashscreen_hBmp,eax
		invoke GetObject,splashscreen_hBmp,sizeof BITMAP,addr bitmap
		
		;---Get Desktopsize---
		invoke GetDesktopWindow
                mov ecx,eax
                invoke GetWindowRect,ecx,addr DesktopRect
                ;---set window size&position---
                push FALSE				;bRepaint
                push bitmap.bmHeight			;nHeight
                push bitmap.bmWidth			;nWidth
                mov  eax,DesktopRect.bottom		;calculate middle...
                sub  eax,bitmap.bmHeight
                shr  eax,1
                push eax				;y position
                mov  eax,DesktopRect.right		;calculate middle...
                sub  eax,bitmap.bmWidth
                shr  eax,1
                push eax				;x position
                push hwnd				;dialog handle
                call MoveWindow

		;---Set time to show the window---
		invoke SetTimer,hwnd,1,3000,0		;3 seconds
	.elseif eax==WM_TIMER
		jmp @close				;time to close...
	.elseif eax==WM_PAINT
		;---draw bitmap---
		invoke BeginPaint,hwnd,addr ps
		mov hdc,eax
		invoke CreateCompatibleDC,hdc
		mov hMemoryDC,eax
		invoke SelectObject,eax,splashscreen_hBmp
		mov esi,eax									;esi=hOldBmp
		invoke GetObject,splashscreen_hBmp,sizeof BITMAP,addr bitmap			;get info about bitmap
		invoke BitBlt,hdc,0,0,bitmap.bmWidth,bitmap.bmHeight,hMemoryDC,0,0,SRCCOPY	;draw bitmap
		invoke SelectObject,hMemoryDC,esi						;esi=hOldBmp
		invoke DeleteDC,hMemoryDC
		invoke EndPaint,hwnd,addr ps
	.elseif eax==WM_CLOSE
		@close:
		invoke EndDialog,hwnd,0			;bye bye...
	.endif
	xor eax,eax
	ret 	                         
DialogProc endp

end main
